# -*- coding: utf-8 -*-
"""
/***************************************************************************
 WypisMPZP
                                 A QGIS plugin
 Wtyczka tworzy wypisy z mpzp gminy Kalwaria Zebrzydowska
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2018-06-10
        git sha              : $Format:%H$
        copyright            : (C) 2018 by Mariusz Jarosz
        email                : mariusz.jarosz@protonmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""
from PyQt5.QtCore import QSettings, QTranslator, qVersion, QCoreApplication
from PyQt5.QtGui import QIcon
from PyQt5.QtWidgets import QAction, QDialogButtonBox
from qgis.core import *
from qgis.utils import *

import sys, json

sys.path.append(r'C:\OSGeo4W64\apps\qgis\python\plugins') # Folder where Processing is located
from processing.core.Processing import Processing
Processing.initialize()
from processing.tools import *
import processing as proc


from odf.userfield import UserFields

# from odf.opendocument import load
# from odf import text


# from odf.opendocument import OpenDocumentText
# from odf.style import Style, TextProperties
# from odf.text import H, P, Span

# from odf import opendocument, chart, text, draw

# from docx import Document

# import win32com.client

# import urllib

# from docxtpl import DocxTemplate, Listing, R, RichText

from jinja2 import Template


# Initialize Qt resources from file resources.py
from .resources import *
# Import the code for the dialog
from .wypis_mpzp_dialog import WypisMPZPDialog
import os.path


class WypisMPZP:
    """QGIS Plugin Implementation."""

    def __init__(self, iface):
        """Constructor.

        :param iface: An interface instance that will be passed to this class
            which provides the hook by which you can manipulate the QGIS
            application at run time.
        :type iface: QgsInterface
        """
        # Save reference to the QGIS interface
        self.iface = iface
        # initialize plugin directory
        self.plugin_dir = os.path.dirname(__file__)
        # initialize locale
        locale = QSettings().value('locale/userLocale')[0:2]
        locale_path = os.path.join(
            self.plugin_dir,
            'i18n',
            'WypisMPZP_{}.qm'.format(locale))

        if os.path.exists(locale_path):
            self.translator = QTranslator()
            self.translator.load(locale_path)

            if qVersion() > '4.3.3':
                QCoreApplication.installTranslator(self.translator)

        # Create the dialog (after translation) and keep reference
        self.dlg = WypisMPZPDialog()

        # Declare instance attributes
        self.actions = []
        self.menu = self.tr(u'&Wypis MPZP')
        # TODO: We are going to let the user set this up in a future iteration
        self.toolbar = self.iface.addToolBar(u'WypisMPZP')
        self.toolbar.setObjectName(u'WypisMPZP')

        # my_path = os.path.abspath(os.path.dirname(__file__))
        # path = os.path.join(my_path, "config.json")

        sciezka = "C:\\qgis_nauka\\Plugins\\wypismpzp\\config.json"

        with open(sciezka, 'r') as f: # Otwieramy plik konfiguracyjny json
            self.stale = json.load(f)
        # Z pliku konfiguracyjnego pobieramy dane i zapisujemy je jako zmienne
        # pole z numerem działki
        self.poleNrDz = self.stale['pozostale']['nazwaPolaNrDzialekDoWyszukiwania']
        # pole z nazwą warstwy wyszukanych działek
        self.nazwaWarWysz = self.stale['pozostale']['nazwaWarstwyZWyszukanymiDzialkami']
        # nr kolumny z symbolem w warstwie planu
        self.nrSymbol = self.stale['pozostale']['nrKolWWarstwiePlanuZSymbolem']
        # nr kolumny z przeznaczeniem w warstwie planu
        self.nrPrzeznaczenie = self.stale['pozostale']['nrKolWWarstwiePlanuZPrzeznaczeniem']



    def testowe(self):
        # test = {}
        # for key, value in self.stale.items():
        #     test.(self, key, value)
        test = self.nazwaWarWysz
        # self.dlg.te_dzialki.setPlainText(str(test))





    # noinspection PyMethodMayBeStatic
    def tr(self, message):
        """Get the translation for a string using Qt translation API.

        We implement this ourselves since we do not inherit QObject.

        :param message: String for translation.
        :type message: str, QString

        :returns: Translated version of message.
        :rtype: QString
        """
        # noinspection PyTypeChecker,PyArgumentList,PyCallByClass
        return QCoreApplication.translate('WypisMPZP', message)


    def add_action(
        self,
        icon_path,
        text,
        callback,
        enabled_flag=True,
        add_to_menu=True,
        add_to_toolbar=True,
        status_tip=None,
        whats_this=None,
        parent=None):
        """Add a toolbar icon to the toolbar.

        :param icon_path: Path to the icon for this action. Can be a resource
            path (e.g. ':/plugins/foo/bar.png') or a normal file system path.
        :type icon_path: str

        :param text: Text that should be shown in menu items for this action.
        :type text: str

        :param callback: Function to be called when the action is triggered.
        :type callback: function

        :param enabled_flag: A flag indicating if the action should be enabled
            by default. Defaults to True.
        :type enabled_flag: bool

        :param add_to_menu: Flag indicating whether the action should also
            be added to the menu. Defaults to True.
        :type add_to_menu: bool

        :param add_to_toolbar: Flag indicating whether the action should also
            be added to the toolbar. Defaults to True.
        :type add_to_toolbar: bool

        :param status_tip: Optional text to show in a popup when mouse pointer
            hovers over the action.
        :type status_tip: str

        :param parent: Parent widget for the new action. Defaults None.
        :type parent: QWidget

        :param whats_this: Optional text to show in the status bar when the
            mouse pointer hovers over the action.

        :returns: The action that was created. Note that the action is also
            added to self.actions list.
        :rtype: QAction
        """

        icon = QIcon(icon_path)
        action = QAction(icon, text, parent)
        action.triggered.connect(callback)
        action.setEnabled(enabled_flag)

        if status_tip is not None:
            action.setStatusTip(status_tip)

        if whats_this is not None:
            action.setWhatsThis(whats_this)

        if add_to_toolbar:
            self.toolbar.addAction(action)

        if add_to_menu:
            self.iface.addPluginToMenu(
                self.menu,
                action)

        self.actions.append(action)

        return action

    def initGui(self):
        """Create the menu entries and toolbar icons inside the QGIS GUI."""

        icon_path = ':/plugins/wypis_mpzp/icon.png'
        self.add_action(
            icon_path,
            text=self.tr(u''),
            callback=self.run,
            parent=self.iface.mainWindow())

        miastoWies = [i for i in self.stale.keys()]
        self.dlg.cb_m_w.addItems(miastoWies[0:2])
        self.listaObrebow()
        self.dlg.cb_m_w.currentIndexChanged.connect(self.listaObrebow)

        self.dlg.button_box.button(QDialogButtonBox.Reset).clicked.connect(self.resetowaniePol)

        self.dlg.pb_dodaj.clicked.connect(self.dodajDzialki)
        self.dlg.pb_usun.clicked.connect(self.usunDzialke)
        self.dlg.pb_wyszukaj.clicked.connect(self.wyszukajDzialki)
        self.dlg.pb_usun_warstwy.clicked.connect(self.wyszukajPrzeznaczenia)
        # self.dlg.pb_testowy.clicked.connect(self.dodaniePrzeznaczenia)


        self.dlg.pb_testowy.clicked.connect(self.dokumentHtml)



    def listaObrebow(self):
        self.dlg.cb_obreb.clear()
        obreby = [obreb for obreb in self.stale[self.dlg.cb_m_w.currentText()]["obreby"].keys()]
        self.dlg.cb_obreb.addItems(obreby)

        # self.dlg.te_dzialki.setPlainText(str(obreby))


    def numerObrebu(self):
        numer = self.stale[self.dlg.cb_m_w.currentText()]["obreby"][self.dlg.cb_obreb.currentText()]["nrobr"]
        return numer
        # self.dlg.te_dzialki.setPlainText(str(numer))

    def dodajDzialki(self):
        lista = self.dlg.te_dzialki
        lista = str(lista.toPlainText()).replace(" ","")
        lista = lista.split(",")
        lista2 = []
        for i in lista:
            lista2.append(self.numerObrebu() + "-" + i)
        test = ','.join(str(x) for x in lista2)
        self.dlg.lista_dzialki.addItems(test.split(","))
        self.dlg.te_dzialki.clear()
        # self.dlg.te_dzialki.setPlainText(str(lista2))
        self.blokujPrzycisk()

    def blokujPrzycisk(self):
        if self.dlg.cb_m_w.currentText() == "miasto":
            self.dlg.cb_m_w.setEnabled(False)
        if self.dlg.cb_m_w.currentText() == "wies":
            self.dlg.cb_m_w.setEnabled(False)
            self.dlg.cb_obreb.setEnabled(False)


    def listaDzialek(self):
        lista_dzialek = [str(self.dlg.lista_dzialki.item(i).text()) for i in range(self.dlg.lista_dzialki.count())]
        return lista_dzialek

    def usunDzialke(self):
        curItem = self.dlg.lista_dzialki.selectedItems()
        if not curItem: return
        for item in curItem:
            self.dlg.lista_dzialki.takeItem(self.dlg.lista_dzialki.row(item))


    def nazwyDzialekTymczasowych(self):
        nazwy = []
        lista_dzialek = self.listaDzialek()
        for i in range(len(lista_dzialek)):
            nazwy.append(lista_dzialek[i])
        # self.dlg.te_dzialki.setPlainText(str(nazwy))
        return nazwy

    def scalanieDzialek(self):
        nazwy = self.nazwyDzialekTymczasowych()
        nazwa_scalony = self.nazwaWarWysz
        params = {'LAYERS': nazwy,
                  'OUTPUT': 'memory'}
        feedback = QgsProcessingFeedback()
        alg_name = 'native:mergevectorlayers'
        res = proc.run(alg_name, params, feedback=feedback)
        layer = QgsVectorLayer(res['OUTPUT'], nazwa_scalony, 'ogr')
        QgsProject.instance().addMapLayer(layer)


    def nazwaWarstwyZDzialkami(self):
        nazwaWarstwy = self.stale[self.dlg.cb_m_w.currentText()]["warstwadz"]
        # self.dlg.te_dzialki.setPlainText(str(nazwaWarstwy))
        return nazwaWarstwy

    def usunWarstwy(self, nazwy):
        self.nazwy = nazwy
        for i in range(len(nazwy)):
            layer = (QgsProject.instance().mapLayersByName(nazwy[i]))
            QgsProject.instance().removeMapLayer(layer[0])

    def wyszukajDzialki(self):
        lista_dzialek = self.listaDzialek()
        poleDz = self.poleNrDz
        cLayer = QgsProject.instance().mapLayersByName(self.nazwaWarstwyZDzialkami())[0]
        crs = cLayer.crs().authid()
        for i in range(len(lista_dzialek)):
            expr = QgsExpression('"' + poleDz +'"' +"="+ "'" + lista_dzialek[i] + "'")
            selected_fid = []
            for feature in cLayer.getFeatures(QgsFeatureRequest(expr)):
                selected_fid.append(feature.id())
                break
            cLayer.select(selected_fid)
            feat = cLayer.selectedFeatures()
            fields = cLayer.fields()
            selection = QgsVectorLayer("Polygon?crs={0}".format(crs), lista_dzialek[i], 'memory')
            dp = selection.dataProvider()
            dp.addAttributes(fields)
            dp.addFeatures(feat)
            selection.commitChanges()
            selection.updateExtents()
            QgsProject.instance().addMapLayer(selection)
            cLayer.removeSelection()
            self.iface.mapCanvas()
        self.scalanieDzialek()
        nazwy = self.nazwyDzialekTymczasowych()
        self.usunWarstwy(nazwy)

    def listaPlanow(self, nazwa_grupy):
        self.nazwa_grupy = nazwa_grupy
        root = QgsProject.instance().layerTreeRoot()
        lista_planow = root.findGroup(nazwa_grupy)
        group = lista_planow.children()
        layers = [item.layer() for item in group]
        return layers

    def nazwaGrupyZPlanami(self):
        nazwaGrupy = self.stale[self.dlg.cb_m_w.currentText()]["obreby"][self.dlg.cb_obreb.currentText()]["warstplan"]
        self.dlg.te_dzialki.setPlainText(str(nazwaGrupy))
        return str(nazwaGrupy)

    def wyszukajPrzeznaczenia(self):
        klucze = self.listaDzialekWyszukanych()
        slownik = {klucz: [] for klucz in klucze}  # Tworzymy słownik o kluczach równych liście działek z pustą listą
        warstwa_dzialek = (QgsProject.instance().mapLayersByName(self.nazwaWarWysz))
        root = QgsProject.instance().layerTreeRoot()
        warstwy_planow = self.listaPlanow("plany-scalone-kalwaria")
        for i in range(len(warstwy_planow)):
            warstwa_planu = root.findLayer(warstwy_planow[i]).layer()
            lista_przeznaczen = []
            lista_dzialek = []
            for i in warstwa_planu.getFeatures():  # Dla każdej cechy w warstwie planów. Nazywamy ją i
                for j in warstwa_dzialek[0].getFeatures():  # Przechodzimy przez każdą cechę w warstwie działek
                    if j.geometry().intersects(i.geometry()):  # Jeżeli warstwy w i, j nachodzą na siebie
                        lista_dzialek.append(j.attributes()[1])  # to bierzemy nazwę atrybutu z kolumny 1 (layer i symbol) i dodajemy je do list
                        if i.attributes()[self.nrSymbol] == NULL: # jeżeli atrybut w kolumnie 1 (np dla strefy konserwatorskiej) jest pusty
                            lista_przeznaczen.append(i.attributes()[self.nrPrzeznaczenie]) # to dodajemy atrybut z kolumny z przeznaczeniem
                        else: # jeżeli nie jest pusty to dodajemy atrybut z kol. 1 (symbol) + " - " + przeznaczenie
                            lista_przeznaczen.append(i.attributes()[self.nrSymbol] + " - " + str(i.attributes()[self.nrPrzeznaczenie]))
            i = 0
            for x in lista_przeznaczen:  # dla każdego elementu z listy przeznaczeń
                slownik[lista_dzialek[i]].append(x)  # aktualizujemy słownik o elementy z listy przeznaczeń
                i += 1
        # self.dlg.te_dzialki.setPlainText(str(slownik))
        return slownik

    def zmianaZmiennejQGIS(self, nazwa_layoutu, nazwa_zmiennej, nowa_wartosc_zmiennej):
        self.nazwa_layoutu = nazwa_layoutu
        self.nazwa_zmiennej = nazwa_zmiennej
        self.nowa_wartosc_zmiennej = nowa_wartosc_zmiennej
        manager = QgsProject.instance().layoutManager()
        QgsExpressionContextUtils.setLayoutVariable(manager.layoutByName(str(nazwa_layoutu)), nazwa_zmiennej, nowa_wartosc_zmiennej)

    def daneWnioskodawcy(self):
        wnioskodawca = self.dlg.pte_wnioskodawcy
        lista_elemntow = str(wnioskodawca.toPlainText()).splitlines()
        # self.dlg.te_dzialki.setPlainText(str(len(lista_elemntow)))
        return lista_elemntow

    # def zmnianaZmiennychWnioskodawcyQGIS(self):
    #     lista_danych = self.daneWnioskodawcy()
    #     if len(lista_danych) > 3:
    #         forma = lista_danych[0]
    #         imie = lista_danych[1].split(" ")[0]
    #         nazwisko = lista_danych[1].split(" ")[1]
    #         adres = lista_danych[2]
    #         miejscowosc = lista_danych[3]
    #     elif len(lista_danych) <= 3:
    #         forma = ""
    #         imie = lista_danych[0]
    #         nazwisko = ""
    #         adres = lista_danych[1]
    #         miejscowosc = lista_danych[2]
    #     nazwa_layoutu = self.nazwaLayoutu()
    #     self.zmianaZmiennejQGIS(nazwa_layoutu, "forma", forma)
    #     self.zmianaZmiennejQGIS(nazwa_layoutu, "imie", imie)
    #     self.zmianaZmiennejQGIS(nazwa_layoutu, "nazwisko", nazwisko)
    #     self.zmianaZmiennejQGIS(nazwa_layoutu, "adres", adres)
    #     self.zmianaZmiennejQGIS(nazwa_layoutu, "kod_miejscowosc", miejscowosc)
    #     # self.dlg.te_dzialki.setPlainText(str(len(lista_danych)))

    def listaDzialekWyszukanych(self):
        warstwa_dzialek = QgsProject.instance().mapLayersByName(self.nazwaWarWysz)[0]
        lista_dzialek = []
        for feature in warstwa_dzialek.getFeatures():
            lista_dzialek.append(feature["layer"])
        # self.dlg.te_dzialki.setPlainText(str(lista_dzialek))
        return lista_dzialek


    def zmianaTytuluWypisu(self):
        nazwa_layoutu = self.nazwaLayoutu()
        tytul = ""
        if self.dlg.cb_m_w.currentText() == "miasto":
            tytul = self.stale["miasto"]["tytulWypisu"]
        elif self.dlg.cb_m_w.currentText() == "wies":
            tytul = self.stale["wies"]["tytulWypisu"] + " " + str(self.dlg.cb_obreb.currentText())
        self.zmianaZmiennejQGIS(nazwa_layoutu, "wypis_miejscowosc", tytul)

    def zmianaZnakuSprawy(self):
        nazwa_layoutu = self.nazwaLayoutu()
        znak_sprawy = str(self.dlg.pte_znak_sprawy.toPlainText()).splitlines()
        self.zmianaZmiennejQGIS(nazwa_layoutu, "znak_sprawy", znak_sprawy)








    # def dodaniePrzeznaczenia(self):
    #     lista_przeznaczen = self.wyszukajPrzeznaczenia() # Słownik z przeznaczeniami dla poszczególnych działek
    #     nr_obrebu = self.numerObrebu()
    #     tekst = "" # tekst, który będzie dodawany do html layoutu
    #     temp = 1 # zmienna tymczasowa,
    #     for i in lista_przeznaczen.keys(): # dla każdej działki
    #         przeznaczenie = "" # zmienna tymczasowa z przeznaczeniem
    #         if temp < len(lista_przeznaczen.keys()): # jeżeli ilość zmienna tymczasowa jest mniejsza od ilości działek
    #             for j in range(len(lista_przeznaczen.get(i))):
    #                 if j < (len(lista_przeznaczen.get(i)) - 1): # jeżeli liczba przeznaczeń dla działki jest większa od 1
    #                     przeznaczenie += lista_przeznaczen.get(i)[j] + ",<br>" # to zmiennej tymczasowej dodajemy przeznaczenie z "," i przechodzimy do nowego wiersza
    #                 else:
    #                     przeznaczenie += lista_przeznaczen.get(i)[j] + ";<br>" # jeżeli jest jedno lub ostatnie przeznaczenie to dodajemy przznaczenie i ";" na końcu i przechodzimy do nowego wiersza
    #             if int(nr_obrebu) < 10:
    #                 tekst += "<br>Działka nr <strong>{}</strong> w jedn.:<br> {}".format(i[2:], przeznaczenie)
    #             else:
    #                 tekst += "<br>Działka nr <strong>{}</strong> w jedn.:<br> {}".format(i[3:], przeznaczenie) # do zmiennej tekst dodajemy sformatowany tekst z działką i przeznaczeniem
    #         else:
    #             for j in range(len(lista_przeznaczen.get(i))):
    #                 if j < (len(lista_przeznaczen.get(i)) - 1):
    #                     przeznaczenie += lista_przeznaczen.get(i)[j] + ",<br>"
    #                 else:
    #                     przeznaczenie += lista_przeznaczen.get(i)[j] + ".<br>" # do ostatniego przeznaczenia w ostatniej działce dodajemy "."
    #                 # self.dlg.te_dzialki.setPlainText(str(j))
    #             if int(nr_obrebu) < 10:
    #                 tekst += "<br>Działka nr <strong>{}</strong> w jedn.:<br> {}".format(i[2:], przeznaczenie)
    #             else:
    #                 tekst += "<br>Działka nr <strong>{}</strong> w jedn.:<br> {}".format(i[3:], przeznaczenie)
    #         temp += 1 # zwiększamy wartość zmiennej tymczasowej
    #     self.zmianaZmiennejQGIS(self.nazwaLayoutu(), "test", tekst) # zmieniamy zmienną test w Layoucie 1 na wartość ze zmiennej tekst
    #     # self.dlg.te_dzialki.setPlainText(str(temp))
    #     # self.zmianaZmiennejLista()


    def nazwaLayoutu(self):
        znak_sprawy = str(self.dlg.pte_znak_sprawy.toPlainText()).splitlines()
        lista_danych = self.daneWnioskodawcy()
        if len(lista_danych) > 3:
            nazwa = lista_danych[1].split(" ")[1]
        if len(lista_danych) <= 3:
            nazwa = lista_danych[0]
        cel = self.dlg.lw_cel.currentItem().text()
        # cel = [str(x.text()) for x in self.dlg.lw_cel.selectedItems()]
        nazwa_pliku = str(znak_sprawy[0]) + "_" + str(nazwa) + "_" + str(cel)
        # self.dlg.te_dzialki.setPlainText(str(nazwa_pliku))
        return nazwa_pliku


    def nowyLayout(self):
        nazwa = self.nazwaLayoutu()
        manager = QgsProject.instance().layoutManager()
        ly = manager.layoutByName("SZABLON")
        manager.duplicateLayout(ly, nazwa)


    def resetowaniePol(self):
        self.dlg.cb_m_w.setEnabled(True)
        self.dlg.cb_obreb.setEnabled(True)
        self.dlg.te_dzialki.clear()
        self.dlg.lista_dzialki.clear()
        self.dlg.pte_znak_sprawy.clear()
        self.dlg.pte_wnioskodawcy.clear()
        self.dlg.te_dzialki.setPlainText(str("test"))


    # def zmianaZmiennejDokumentu(self, nazwa_dokumentu, nazwa_zmiennej, nowa_wartosc_zmiennej):
    #     self.nazwa_dokumentu = nazwa_dokumentu
    #     self.nazwa_zmiennej = nazwa_zmiennej
    #     self.nowa_wartosc_zmiennej = nowa_wartosc_zmiennej
    #     manager = QgsProject.instance().layoutManager()
    #     QgsExpressionContextUtils.setLayoutVariable(manager.layoutByName(str(nazwa_layoutu)), nazwa_zmiennej, nowa_wartosc_zmiennej)
    #
    #     obj = UserFields(nazwa_dokumentu,
    #                      nazwa_dokumentu)
    #     znak_sprawy = self.dlg.pte_znak_sprawy.toPlainText()
    #
    #     dzialki_do_listy = self.zmianaZmiennejLista()
    #     dzialki = self.listaDzialekWyszukanych()
    #     dzialk = "działka"
    #     polozon = "położona"
    #     znajduj = "znajduje"
    #     if len(dzialki) > 1:
    #         dzialk = "działki"
    #         polozon = "położone"
    #         znajduj = "znajdują"
    #
    #     self.dlg.te_dzialki.setPlainText(str(len(dzialki)))

        # obj.update({"znak_sprawy": znak_sprawy,
        #             "lista_dzialek": dzialki_do_listy,
        #             "dzialk": dzialk,
        #             "polozon": polozon,
        #             "znajduj": znajduj})

    def zmianaZmiennejLista(self):
        dzialki = self.listaDzialekWyszukanych()
        nr_obrebu = self.numerObrebu()
        if int(nr_obrebu) < 10:
            dzialki_po = str([i[2:] for i in dzialki]) # bierzemy listę działek i zamieniamy ją na string
        else:
            dzialki_po = str([i[3:] for i in dzialki]) # bierzemy listę działek i zamieniamy ją na string
        znaki_do_usuniecia = "''[]"
        for znak in znaki_do_usuniecia: dzialki_po = dzialki_po.replace(znak, "") # filtrujemy działki i usuwamy niepotrzebne znaki
        return dzialki_po
        # self.dlg.te_dzialki.setPlainText(dzialki_po)

    def zmianaDanychWnioskodawcy(self):
        lista_danych = self.daneWnioskodawcy()
        if len(lista_danych) > 3:
            forma = lista_danych[0]
            imie = lista_danych[1].split(" ")[0]
            nazwisko = lista_danych[1].split(" ")[1]
            adres = lista_danych[2]
            miejscowosc = lista_danych[3]
        elif len(lista_danych) <= 3:
            forma = ""
            imie = lista_danych[0]
            nazwisko = ""
            adres = lista_danych[1]
            miejscowosc = lista_danych[2]
        return [forma,imie,nazwisko,adres,miejscowosc]

    def nazwaDokumentu(self):
        znak_sprawy = str(self.dlg.pte_znak_sprawy.toPlainText()).splitlines()
        lista_danych = self.daneWnioskodawcy()
        if len(lista_danych) > 3:
            nazwa = lista_danych[1].split(" ")[1]
        if len(lista_danych) <= 3:
            nazwa = lista_danych[0]
        cel = self.dlg.lw_cel.currentItem().text()
        # cel = [str(x.text()) for x in self.dlg.lw_cel.selectedItems()]
        nazwa_pliku = str(znak_sprawy[0]) + "_" + str(nazwa) + "_" + str(cel)
        # self.dlg.te_dzialki.setPlainText(str(nazwa_pliku))
        return nazwa_pliku


    def dodaniePrzeznaczenia(self):
        lista_przeznaczen = self.wyszukajPrzeznaczenia() # Słownik z przeznaczeniami dla poszczególnych działek
        nr_obrebu = self.numerObrebu()
        tekst = "" # tekst, który będzie dodawany do html layoutu
        temp = 1 # zmienna tymczasowa,
        for i in lista_przeznaczen.keys(): # dla każdej działki
            przeznaczenie = "" # zmienna tymczasowa z przeznaczeniem
            if temp < len(lista_przeznaczen.keys()): # jeżeli ilość zmienna tymczasowa jest mniejsza od ilości działek
                for j in range(len(lista_przeznaczen.get(i))):
                    if j < (len(lista_przeznaczen.get(i)) - 1): # jeżeli liczba przeznaczeń dla działki jest większa od 1
                        przeznaczenie += lista_przeznaczen.get(i)[j] + ",<br>" # to zmiennej tymczasowej dodajemy przeznaczenie z "," i przechodzimy do nowego wiersza
                    else:
                        przeznaczenie += lista_przeznaczen.get(i)[j] + ";<br>" # jeżeli jest jedno lub ostatnie przeznaczenie to dodajemy przznaczenie i ";" na końcu i przechodzimy do nowego wiersza
                if int(nr_obrebu) < 10:
                    tekst += "<br>Działka nr <strong>{}</strong> w jedn.:<br> {}".format(i[2:], przeznaczenie)
                else:
                    tekst += "<br>Działka nr <strong>{}</strong> w jedn.:<br> {}".format(i[3:], przeznaczenie) # do zmiennej tekst dodajemy sformatowany tekst z działką i przeznaczeniem
            else:
                for j in range(len(lista_przeznaczen.get(i))):
                    if j < (len(lista_przeznaczen.get(i)) - 1):
                        przeznaczenie += lista_przeznaczen.get(i)[j] + ",<br>"
                    else:
                        przeznaczenie += lista_przeznaczen.get(i)[j] + ".<br>" # do ostatniego przeznaczenia w ostatniej działce dodajemy "."
                    # self.dlg.te_dzialki.setPlainText(str(j))
                if int(nr_obrebu) < 10:
                    tekst += "<br>Działka nr <strong>{}</strong> w jedn.:<br> {}".format(i[2:], przeznaczenie)
                else:
                    tekst += "<br>Działka nr <strong>{}</strong> w jedn.:<br> {}".format(i[3:], przeznaczenie)
            temp += 1 # zwiększamy wartość zmiennej tymczasowej
        return tekst
        # self.dlg.te_dzialki.setPlainText(str(temp))
        # self.zmianaZmiennejLista()

    def dokumentHtml(self):
        # szablon = Template('Hello {{ znak_sprawy }}')
        przeznaczenie = self.dodaniePrzeznaczenia()
        znak_sprawy = self.dlg.pte_znak_sprawy.toPlainText()
        dzialki_do_listy = self.zmianaZmiennejLista()
        dzialki = self.listaDzialekWyszukanych()
        dzialk = "działka"
        polozon = "położona"
        znajduj = "znajduje"

        if len(dzialki) > 1:
            dzialk = "działki"
            polozon = "położone"
            znajduj = "znajdują"

        dane_wnioskodawcy = self.zmianaDanychWnioskodawcy()
        forma = dane_wnioskodawcy[0]
        imie = dane_wnioskodawcy[1]
        nazwisko = dane_wnioskodawcy[2]
        adres = dane_wnioskodawcy[3]
        miejscowosc = dane_wnioskodawcy[4]

        with open("C:\\Users\\Mariusz\\Desktop\\test\\bugaj.html", "r") as f:
             szablon= Template(f.read())
        with open('C:\\Users\\Mariusz\\Desktop\\test\\1.html', 'w') as f:
            f.write(szablon.render(znak_sprawy = znak_sprawy,
                                   przeznaczenie=przeznaczenie,
                                   forma=forma,
                                   imie=imie,nazwisko=nazwisko,
                                   adres=adres,
                                   kod_miejscowosc=miejscowosc,
                                   lista_dzialek=dzialki_do_listy,
                                   dzialk=dzialk,
                                   polozon=polozon,
                                   znajduj=znajduj))
        self.dlg.te_dzialki.setPlainText(str(szablon))




    # def zmianaDokumentu(self):
    #     doc = DocxTemplate("C:\\Users\\Mariusz\\Desktop\\test\\wzor.docx")
    #
    #
    #     nazwa_dokumentu = self.nazwaDokumentu()
    #     # obj = UserFields('C:\\Users\\Mariusz\\Desktop\\test\\wzor_bugaj.odt',
    #     #                  'C:\\Users\\Mariusz\\Desktop\\test\\test123.odt')
    #     znak_sprawy = self.dlg.pte_znak_sprawy.toPlainText()
    #
    #     dzialki_do_listy = self.zmianaZmiennejLista()
    #     dzialki = self.listaDzialekWyszukanych()
    #     dzialk = "działka"
    #     polozon = "położona"
    #     znajduj = "znajduje"
    #
    #     if len(dzialki) > 1:
    #         dzialk = "działki"
    #         polozon = "położone"
    #         znajduj = "znajdują"
    #
    #     dane_wnioskodawcy = self.zmianaDanychWnioskodawcy()
    #     forma = dane_wnioskodawcy[0]
    #     imie = dane_wnioskodawcy[1]
    #     nazwisko = dane_wnioskodawcy[2]
    #     adres = dane_wnioskodawcy[3]
    #     miejscowosc = dane_wnioskodawcy[4]
    #
    #     przeznaczenie = self.dodaniePrzeznaczenia()
    #
    #     context = {'znak_sprawy': znak_sprawy,
    #                "przeznaczenie": Listing(przeznaczenie)
    #                }
    #
    #     doc.render(context)
    #     doc.save("C:\\Users\\Mariusz\\Desktop\\test\\test.docx")



    # def tworzenieDokumentu(self):
    #     output = pypandoc.convert(source='/path/to/file.html', format='html', to='docx', outputfile='/path/to/output.docx',
    #                           extra_args=['-RTS'])

    # def tworzenieDokumentu(self):
    #     document = Document('C:\\Users\\Mariusz\\Desktop\\test\\word.docx')
    #     document.save('C:\\Users\\Mariusz\\Desktop\\test\\word.docx')




    # def tworzenieDokumentu(self):
        # nazwa_dokumentu = self.nazwaDokumentu()
        # obj = UserFields('C:\\Users\\Mariusz\\Desktop\\test\\wzor_bugaj.odt',
        #                  'C:\\Users\\Mariusz\\Desktop\\test\\test123.odt')
        # znak_sprawy = self.dlg.pte_znak_sprawy.toPlainText()
        #
        # dzialki_do_listy = self.zmianaZmiennejLista()
        # dzialki = self.listaDzialekWyszukanych()
        # dzialk = "działka"
        # polozon = "położona"
        # znajduj = "znajduje"
        #
        # if len(dzialki) > 1:
        #     dzialk = "działki"
        #     polozon = "położone"
        #     znajduj = "znajdują"
        #
        # dane_wnioskodawcy = self.zmianaDanychWnioskodawcy()
        # forma = dane_wnioskodawcy[0]
        # imie = dane_wnioskodawcy[1]
        # nazwisko = dane_wnioskodawcy[2]
        # adres = dane_wnioskodawcy[3]
        # miejscowosc = dane_wnioskodawcy[4]
        #
        # przeznaczenie = self.dodaniePrzeznaczenia()
        #
        #
        # obj.update({"znak_sprawy": znak_sprawy,
        #             "lista_dzialek": dzialki_do_listy,
        #             "dzialk":dzialk,
        #             "polozon":polozon,
        #             "znajduj":znajduj,
        #             "forma":forma,
        #             "imie":imie,
        #             "nazwisko":nazwisko,
        #             "adres":adres,
        #             "kod_miejscowosc":miejscowosc,
        #             "przeznaczenie":przeznaczenie})




        # textdoc.save("C:\\Users\\Mariusz\\Desktop\\test\\test.odt")













    def unload(self):
        """Removes the plugin menu item and icon from QGIS GUI."""
        for action in self.actions:
            self.iface.removePluginMenu(
                self.tr(u'&Wypis MPZP'),
                action)
            self.iface.removeToolBarIcon(action)
        # remove the toolbar
        del self.toolbar


    def run(self):
        """Run method that performs all the real work"""
        # show the dialog
        self.dlg.show()
        # Run the dialog event loop
        result = self.dlg.exec_()
        # See if OK was pressed
        if result:
            pass
            # Do something useful here - delete the line containing pass and
            # substitute with your code.
            # self.nowyLayout()
            # self.zmianaZnakuSprawy()
            # self.zmianaTytuluWypisu()
            # self.zmianaZmiennejLista()
            # self.zmnianaZmiennychWnioskodawcyQGIS()
            # self.dodaniePrzeznaczenia()
            # warstwaDoUsuniecia = QgsProject.instance().mapLayersByName(self.nazwaWarWysz)
            # QgsProject.instance().removeMapLayer(warstwaDoUsuniecia[0])
            # self.resetowaniePol()


